# -*- coding: utf-8 -*-

import grok

from hurry import yui
from zope.component import getMultiAdapter
from zope.location.interfaces import ISite
from waeup.browser.pages import UniversityPage, FacultyContainerPage
from waeup.interfaces import (IUniversity, IWAeUPObject, IWAeUPXMLExporter,
                              IWAeUPXMLImporter, IFacultyContainer, IFaculty,
                              IDepartment, ICourse, ICertificate,
                              ICertificateCourse,)
from waeup.utils.helpers import getInnerHTMLPart
from waeup.viewlets import LeftSidebar, ActionBar

grok.templatedir('templates')

#grok.context(zope.interface.Interface)

#
# waeup.app.University viewlets...
#
class Login(grok.Viewlet):
    """This viewlet allows to login in the sidebar.
    """
    grok.viewletmanager(LeftSidebar)
    grok.context(IUniversity)
    grok.view(UniversityPage)
    grok.order(2)

    def isAuthenticated(self):
        """Is the calling user authenticated?
        """
        return self.request.principal.id != 'zope.anybody'

class ManageLink(grok.Viewlet):
    grok.viewletmanager(LeftSidebar)
    grok.context(IUniversity)
    grok.view(UniversityPage)
    grok.order(5)
    # This link is only displayed, if the user is
    # allowed to use it!
    grok.require('waeup.manageUniversity')
    
    def render(self):
        return u'<div class="portlet"><a href="manage">Settings</a></div>'

class ManageFacultiesLink(grok.Viewlet):
    grok.viewletmanager(LeftSidebar)
    grok.context(IUniversity)
    grok.view(UniversityPage)
    grok.order(6)
    # This is so cool! This link is only displayed, when the user is
    # allowed to use it!
    grok.require('waeup.manageUniversity')
    
    def render(self):
        return u'<div class="portlet"><a href="faculties">Manage faculties</a></div>'

class ManageUsersLink(grok.Viewlet):
    grok.viewletmanager(LeftSidebar)
    grok.context(IUniversity)
    grok.view(UniversityPage)
    grok.order(6)
    grok.require('waeup.manageUsers')

    def render(self):
        return u'<div class="portlet"><a href="users">Manage users</a></div>'

class ManageDataCenter(grok.Viewlet):
    grok.viewletmanager(LeftSidebar)
    grok.context(IUniversity)
    grok.view(UniversityPage)
    grok.order(6)
    grok.require('waeup.manageUniversity')

    def render(self):
        return u'<div class="portlet"><a href="datacenter">Data Center</a></div>'

class ManageUniversityAction(grok.Viewlet):
    grok.viewletmanager(ActionBar)
    grok.context(IUniversity)
    grok.view(UniversityPage)
    grok.require('waeup.manageUniversity')
    grok.order(2)
    grok.template('manageaction')

class GoToFacultiesAction(grok.Viewlet):
    grok.viewletmanager(ActionBar)
    grok.context(IUniversity)
    grok.view(UniversityPage)
    grok.require('waeup.manageUniversity')
    grok.order(3)
    grok.template('gotofacultiesaction')

class ManageFacultiesAction(ManageUniversityAction):
    grok.context(IFacultyContainer)
    grok.view(FacultyContainerPage)
    grok.template('manageaction')
